from __future__ import division

import cocos
from cocos.director import director
from cocos import sprite
from cocos.actions import FadeTo, Delay
import pyglet
import random
import subprocess
import os
import collections

pyglet.resource.path.append("/home/facundo/Escritorio/present_cierre/juegos")
pyglet.resource.reindex()

class pantalla(object):
    width = 1024
    height = 768

FINAL = True

class Recorder(object):
    def __init__(self):
        self.c = 0
        buffers = pyglet.image.get_buffer_manager()
        self.cbuf = buffers.get_color_buffer()
        for x in os.listdir("filminas/"):
            os.remove(os.path.join("filminas", x))

    def __call__(self, t):
        '''time adjust.'''
        if FINAL:
            return t * 10
        else:
            return t

    def snapshot(self, dt):
        '''takes a snapshot'''
        n = "filminas/img%06d.png" % self.c
        self.c += 1
        self.cbuf.save(n)

    def generate(self):
        '''make the video.'''
        cmd = "mencoder mf://filminas/*.png -mf fps=30 -o foo.avi -ovc lavc"
        if FINAL:
            subprocess.call(cmd.split())
        exit()


def get_foto():
    imags = os.listdir("/home/facundo/Escritorio/present_cierre/juegos")
    random.shuffle(imags)
    for imag in imags:
        yield imag


class TestLayer(cocos.layer.Layer):
    def __init__(self):
        super( TestLayer, self ).__init__()
        self.r = Recorder()

        self.imags = get_foto()
        self.fly_image()
        self.schedule_interval(self.fly_image, self.r(1.1))
        self.schedule_interval(self.r.snapshot, self.r(1/30.0))

    def stop(self, _):
        '''stop it'''
        self.unschedule(self.fly_image)
        self.unschedule(self.r.snapshot)
        self.unschedule(self.stop)
        self.r.generate()

    def fly_image(self, dt=None):
        '''Makes image fly.'''
        # get the image
        try:
            imag = self.imags.next()
        except StopIteration:
            self.schedule_interval(self.stop, self.r(.3))
            return
        sp = sprite.Sprite(imag)
        xtra_x = (pantalla.width - sp.width) * .95  // 2
        xtra_y = (pantalla.height - sp.height) * .95 // 2
        x = pantalla.width//2 + random.randint(-xtra_x, xtra_x)
        y = pantalla.height//2 + random.randint(-xtra_y, xtra_y)
        sp.position = x, y

        # load the sprite
        sp.opacity = 0
        self.add(sp)

        # fade it in and out
        sp.do(FadeTo(255, self.r(.3)) + Delay(self.r(.7)) + FadeTo(0, self.r(.3)))


if __name__ == "__main__":
    director.init(pantalla.width, pantalla.height)
    test_layer = TestLayer ()
    main_scene = cocos.scene.Scene (test_layer)
#    director.show_FPS = True
    director.run (main_scene)
